Gio::DBus::ObjectProxy Class Reference
D-Bus API

Client-side D-Bus object. More...

`#include <giomm/dbusobjectproxy.h>`

Inheritance diagram for Gio::DBus::ObjectProxy:
[legend]

## Public Member Functions

| ObjectProxy (ObjectProxy&& src) noexcept
ObjectProxy& | operator= (ObjectProxy&& src) noexcept
| ~ObjectProxy () noexcept override
GDBusObjectProxy* | gobj ()
| Provides access to the underlying C GObject. More...
const GDBusObjectProxy* | gobj () const
| Provides access to the underlying C GObject. More...
GDBusObjectProxy* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Connection > | get_connection ()
| Gets the connection that proxy is for. More...
Glib::RefPtr< const Connection > | get_connection () const
| Gets the connection that proxy is for. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Connection > > | property_g_connection () const
| The connection of the proxy. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_g_object_path () const
| The object path of the proxy. More...
Public Member Functions inherited from Glib::Object
| Object (const Object&)=delete
Object& | operator= (const Object&)=delete
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const
Public Member Functions inherited from Gio::DBus::Object
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
| ~Object () noexcept override
GDBusObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GDBusObject* | gobj () const
| Provides access to the underlying C GObject. More...
Glib::ustring | get_object_path () const
| Gets the object path for object. More...
std::vector< Glib::RefPtr< Gio::DBus::Interface > > | get_interfaces ()
| Gets the D-Bus interfaces associated with object. More...
std::vector< Glib::RefPtr< const Gio::DBus::Interface > > | get_interfaces () const
| Gets the D-Bus interfaces associated with object. More...
Glib::RefPtr< Gio::DBus::Interface > | get_interface (const Glib::ustring& interface_name)
| Gets the D-Bus interface with name interface_name associated with object, if any. More...
Glib::RefPtr< const Gio::DBus::Interface > | get_interface (const Glib::ustring& interface_name) const
| Gets the D-Bus interface with name interface_name associated with object, if any. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gio::DBus::Interface >& > | signal_interface_added ()
Glib::SignalProxy< void, const Glib::RefPtr< Gio::DBus::Interface >& > | signal_interface_removed ()
virtual Glib::ustring | get_object_path_vfunc () const
virtual std::vector< Glib::RefPtr< Gio::DBus::Interface > > | get_interfaces_vfunc () const
virtual Glib::RefPtr< Gio::DBus::Interface > | get_interface_vfunc (const Glib::ustring& interface_name) const
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (Interface&& src) noexcept
Interface& | operator= (Interface&& src) noexcept
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
| ~Interface () noexcept override
| Interface (const Interface&)=delete
Interface& | operator= (const Interface&)=delete
GObject* | gobj ()
const GObject* | gobj () const

## Static Public Member Functions

static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< ObjectProxy > | create (const Glib::RefPtr< Connection >& connection, const Glib::ustring& object_path)
| Creates a new Gio::DBus::ObjectProxy for the given connection and object path. More...
Static Public Member Functions inherited from Gio::DBus::Object
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions

| ObjectProxy (const Glib::RefPtr< Connection >& connection, const Glib::ustring& object_path)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)
Protected Member Functions inherited from Gio::DBus::Object
| Object ()
| You should derive from this class to use it. More...
virtual void | on_interface_added (const Glib::RefPtr< Gio::DBus::Interface >& iface)
| This is a default handler for the signal signal_interface_added(). More...
virtual void | on_interface_removed (const Glib::RefPtr< Gio::DBus::Interface >& iface)
| This is a default handler for the signal signal_interface_removed(). More...

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr< Gio::DBus::ObjectProxy > | wrap (GDBusObjectProxy* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)
Related Functions inherited from Gio::DBus::Object
Glib::RefPtr< Gio::DBus::Object > | wrap (GDBusObject* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members

Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Client-side D-Bus object.

A Gio::DBus::ObjectProxy is an object used to represent a remote object with one or more D-Bus interfaces. Normally, you don't instantiate a Gio::DBus::ObjectProxy yourself - typically Gio::DBus::ObjectManagerClient is used to obtain it.

Since glibmm 2.62:

## Constructor & Destructor Documentation

Gio::DBus::ObjectProxy::ObjectProxy | ( | ObjectProxy&& | src | ) |

noexcept

Gio::DBus::ObjectProxy::~ObjectProxy | ( |  | ) |

overridenoexcept

Gio::DBus::ObjectProxy::ObjectProxy | ( | const Glib::RefPtr< Connection >& | connection,
|  | const Glib::ustring& | object_path
| ) |  |

explicitprotected

## Member Function Documentation

static Glib::RefPtr<ObjectProxy> Gio::DBus::ObjectProxy::create | ( | const Glib::RefPtr< Connection >& | connection,
|  | const Glib::ustring& | object_path
| ) |  |

static

Creates a new Gio::DBus::ObjectProxy for the given connection and object path.

Parameters

  connection | A Gio::DBus::Connection.
  object_path | The object path.

Returns
  A new Gio::DBus::ObjectProxy.

Glib::RefPtr<Connection> Gio::DBus::ObjectProxy::get_connection | ( |  | ) |

Gets the connection that proxy is for.

Since glibmm 2.30:

Returns
  A DBusConnection. Do not free, the object is owned by proxy.

Glib::RefPtr<const Connection> Gio::DBus::ObjectProxy::get_connection | ( |  | ) | const

Gets the connection that proxy is for.

Since glibmm 2.30:

Returns
  A DBusConnection. Do not free, the object is owned by proxy.

static GType Gio::DBus::ObjectProxy::get_type | ( |  | ) |

static

Get the GType for this class, for use with the underlying GObject type system.

GDBusObjectProxy* Gio::DBus::ObjectProxy::gobj | ( |  | ) |

inline

Provides access to the underlying C GObject.

const GDBusObjectProxy* Gio::DBus::ObjectProxy::gobj | ( |  | ) | const

inline

Provides access to the underlying C GObject.

GDBusObjectProxy* Gio::DBus::ObjectProxy::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

ObjectProxy& Gio::DBus::ObjectProxy::operator= | ( | ObjectProxy&& | src | ) |

noexcept

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Connection> > Gio::DBus::ObjectProxy::property_g_connection | ( |  | ) | const

The connection of the proxy.

Since glibmm 2.30:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gio::DBus::ObjectProxy::property_g_object_path | ( |  | ) | const

The object path of the proxy.

Since glibmm 2.30:

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::DBus::ObjectProxy > wrap | ( | GDBusObjectProxy * | object,
|  | bool | take_copy = `false`
| ) |  |

related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.